﻿namespace WiseJTest.Components;

using System;
using System.Drawing;
using System.Linq;
using Wisej.Web;

public partial class MainForm : Form
{
    public MainForm()
    {
        InitializeComponent();
    }

    // Form event handlers

    private void MainForm_Shown(object sender, EventArgs e)
    {
        labelVersion.Text = string.Format("v{0}", Program.Version);

        LoadAccountsList();
    }

    private void MainForm_Load(object sender, EventArgs e)
    {
    }

    private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
    {
        Application.Exit();
    }

    private void menuQuit_Click(object sender, EventArgs e)
    {
        Application.Exit();
    }

    private void listAccounts_SelectedValueChanged(object sender, EventArgs e)
    {
        txtSteamGuard.Text = $"ABCD{listAccounts.SelectedIndex}";
        groupAccount.Text = "Account: " + listAccounts.SelectedItem;
    }

    private void btnCopy_Click(object sender, EventArgs e)
    {
        CopyLoginToken();
    }

    private void CopyLoginToken()
    {
        string text = txtSteamGuard.Text;
        if (string.IsNullOrEmpty(text))
        {
            return;
        }

        Clipboard.SetClientText(text);
    }

    private void LoadAccountsList()
    {
        listAccounts.Items.Clear();
        listAccounts.SelectedIndex = -1;
        for (int i = 0; i < 5; i++)
        {
            listAccounts.Items.Add($"Example Account {i + 1}");
        }

        listAccounts.SelectedIndex = 0;
    }

    private void listAccounts_KeyDown(object sender, KeyEventArgs e)
    {

        if (!IsKeyAChar(e.KeyCode) && !IsKeyADigit(e.KeyCode))
        {
            return;
        }

        txtAccSearch.Focus();
        txtAccSearch.Text = e.KeyCode.ToString();
        txtAccSearch.SelectionStart = 1;
    }

    private static bool IsKeyAChar(Keys key)
    {
        return key >= Keys.A && key <= Keys.Z;
    }

    private static bool IsKeyADigit(Keys key)
    {
        return (key >= Keys.D0 && key <= Keys.D9) || (key >= Keys.NumPad0 && key <= Keys.NumPad9);
    }

    private void MainForm_KeyDown(object sender, KeyEventArgs e)
    {
        if (e.KeyCode == Keys.C && e.Modifiers == Keys.Control)
        {
            CopyLoginToken();
        }
    }
}