namespace WiseJTest;

using Microsoft.AspNetCore.Builder;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using Wisej.Core;

/// <summary>
///     The Startup class configures services and the app's request pipeline.
///     For more information on how to configure your application, visit https://go.microsoft.com/fwlink/?LinkID=398940.
/// </summary>
public class Startup
{
    public Startup(IConfiguration configuration)
    {
        Configuration = configuration;
    }

    public IConfiguration Configuration { get; }

    public static void Main(string[] args)
    {
        WebApplicationBuilder builder = WebApplication.CreateBuilder(
            new WebApplicationOptions
            {
                Args = args,
                WebRootPath = "./",
            });

        // ignore Microsoft.AspNetCore.Hosting.Diagnostics logs
        builder.Logging.AddFilter("Microsoft.AspNetCore.Hosting.Diagnostics", LogLevel.Warning);
        builder.Logging.AddFilter("Microsoft.AspNetCore.Server.Kestrel", LogLevel.Warning);

        WebApplication app = builder.Build();
        app.UseWisej();
        app.UseFileServer();

        app.Run();
    }
}